"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Client = void 0;
require("isomorphic-fetch");
var qs_1 = require("qs");
var clientOptions_1 = require("./clientOptions");
var sdkVersion_1 = require("./sdkVersion");
var notNil = function (v) { return !(typeof v === 'undefined' || v === null || ((v.constructor === String || v instanceof String) && v.trim() === '')); };
var TOKENS_REG_EX = new RegExp(/\/{(.*?)}/g);
var replaceParams = function (str, params) { return str.replace(TOKENS_REG_EX, function (_, p) { return params[p] ? "/".concat(params[p]) : '/'; }); };
function defaultFormatter(response) {
    if (response.body !== undefined && response.body !== null) {
        return response.json();
    }
    return Promise.resolve({});
}
var baseRequest = function (defaults, options) { return function (url, config, reqConfig) {
    var headers = new Headers();
    headers.append('Accept', 'application/json');
    headers.append('Content-Type', 'application/json');
    headers.append('Procore-Sdk-Version', sdkVersion_1.sdkVersionHeader);
    headers.append('Procore-Sdk-language', 'javascript');
    if (reqConfig === null || reqConfig === void 0 ? void 0 : reqConfig.companyId) {
        headers.append('Procore-Company-Id', "".concat(reqConfig.companyId));
    }
    else if (options === null || options === void 0 ? void 0 : options.defaultCompanyId) {
        headers.append('Procore-Company-Id', "".concat(options.defaultCompanyId));
    }
    if (config.headers) {
        if (config.headers instanceof Headers) {
            config.headers.forEach(function (value, name) {
                headers.set(name, value);
            });
        }
        else if (config.headers) {
            Object.getOwnPropertyNames(config.headers).forEach(function (name) {
                headers.set(name, config.headers[name]);
            });
        }
    }
    var opts = __assign(__assign(__assign({ mode: 'cors', credentials: 'include' }, defaults), config), { headers: headers });
    return function authorizedRequest(_a) {
        var authKey = _a[0], authValue = _a[1];
        return __awaiter(this, void 0, void 0, function () {
            var formatter, request, response, body;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        opts.headers.set(authKey, authValue);
                        // Add custom headers if provided in RequestConfig
                        if (reqConfig === null || reqConfig === void 0 ? void 0 : reqConfig.headers) {
                            Object.keys(reqConfig.headers).forEach(function (key) {
                                opts.headers.set(key, reqConfig.headers[key]);
                            });
                        }
                        formatter = reqConfig && reqConfig.formatter ? reqConfig.formatter : defaultFormatter;
                        request = fetch(url, opts);
                        return [4 /*yield*/, request];
                    case 1:
                        response = _b.sent();
                        return [4 /*yield*/, formatter(response)];
                    case 2:
                        body = _b.sent();
                        return [2 /*return*/, new Promise(function (resolve, reject) {
                                var sdkResp = { body: body, request: request, response: response };
                                response.ok ? resolve(sdkResp) : reject(sdkResp);
                            })];
                }
            });
        });
    };
}; };
var Client = /** @class */ (function () {
    function Client(authorizer, config, options) {
        if (config === void 0) { config = {}; }
        var _this = this;
        this.get = function (endpoint, reqConfig) {
            return _this.authorize(_this.request(_this.url(endpoint), { method: 'GET' }, reqConfig));
        };
        this.post = function (endpoint, payload, reqConfig) {
            return _this.authorize(_this.request(_this.url(endpoint), { method: 'POST', body: JSON.stringify(payload) }, reqConfig));
        };
        this.patch = function (endpoint, payload, reqConfig) {
            return _this.authorize(_this.request(_this.url(endpoint), { method: 'PATCH', body: JSON.stringify(payload) }, reqConfig));
        };
        this.put = function (endpoint, payload, reqConfig) {
            return _this.authorize(_this.request(_this.url(endpoint), { method: 'PUT', body: JSON.stringify(payload) }, reqConfig));
        };
        this.delete = function (endpoint, payload, reqConfig) {
            return _this.authorize(_this.request(_this.url(endpoint), { method: 'DELETE', body: JSON.stringify(payload) }, reqConfig));
        };
        this.url = function (endpoint) {
            return notNil(endpoint) && (endpoint.constructor === String || endpoint instanceof String) ?
                "".concat(_this.options.apiHostname).concat(endpoint) :
                _this.urlConfig(endpoint);
        };
        this.urlConfig = function (_a) {
            var base = _a.base, action = _a.action, _b = _a.params, params = _b === void 0 ? {} : _b, qs = _a.qs, version = _a.version;
            var url;
            if (_this.version(version) === '') {
                url = "".concat(_this.options.apiHostname).concat(replaceParams(base, params));
            }
            else {
                url = "".concat(_this.options.apiHostname, "/").concat(_this.version(version)).concat(replaceParams(base, params));
            }
            if (notNil(params.id)) {
                url = "".concat(url, "/").concat(params.id);
            }
            if (notNil(action)) {
                url = "".concat(url, "/").concat(action);
            }
            if (notNil(qs)) {
                url = "".concat(url, "?").concat((0, qs_1.stringify)(qs, { arrayFormat: 'brackets' }));
            }
            return url;
        };
        this.version = function (version) {
            if (version === void 0) { version = _this.options.defaultVersion; }
            if (version === 'unversioned') {
                return '';
            }
            var _a = version.match(/^(v[1-9]\d*\.\d+)$/) || [], _b = _a[1], restVersion = _b === void 0 ? undefined : _b;
            var _c = version.match(/^(vapid)\/?$/) || [], _d = _c[1], vapidVersion = _d === void 0 ? undefined : _d;
            if (restVersion) {
                return "rest/".concat(restVersion);
            }
            else if (vapidVersion) {
                return vapidVersion;
            }
            else {
                throw new Error("'".concat(version, "' is an invalid Procore API version"));
            }
        };
        this.authorize = authorizer.authorize;
        this.options = options;
        this.request = baseRequest(config, options);
    }
    return Client;
}());
exports.Client = Client;
function client(authorizer, defaults, options) {
    if (defaults === void 0) { defaults = {}; }
    return new Client(authorizer, defaults, (0, clientOptions_1.convert)(options));
}
exports.default = client;
